// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package cryptpb

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CryptServiceClient is the client API for CryptService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CryptServiceClient interface {
	Encrypt(ctx context.Context, opts ...grpc.CallOption) (CryptService_EncryptClient, error)
	Decrypt(ctx context.Context, opts ...grpc.CallOption) (CryptService_DecryptClient, error)
}

type cryptServiceClient struct {
	cc grpc.ClientConnInterface
}

func NewCryptServiceClient(cc grpc.ClientConnInterface) CryptServiceClient {
	return &cryptServiceClient{cc}
}

func (c *cryptServiceClient) Encrypt(ctx context.Context, opts ...grpc.CallOption) (CryptService_EncryptClient, error) {
	stream, err := c.cc.NewStream(ctx, &CryptService_ServiceDesc.Streams[0], "/cryptpb.CryptService/Encrypt", opts...)
	if err != nil {
		return nil, err
	}
	x := &cryptServiceEncryptClient{stream}
	return x, nil
}

type CryptService_EncryptClient interface {
	Send(*EncryptRequest) error
	Recv() (*EncryptResponse, error)
	grpc.ClientStream
}

type cryptServiceEncryptClient struct {
	grpc.ClientStream
}

func (x *cryptServiceEncryptClient) Send(m *EncryptRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *cryptServiceEncryptClient) Recv() (*EncryptResponse, error) {
	m := new(EncryptResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *cryptServiceClient) Decrypt(ctx context.Context, opts ...grpc.CallOption) (CryptService_DecryptClient, error) {
	stream, err := c.cc.NewStream(ctx, &CryptService_ServiceDesc.Streams[1], "/cryptpb.CryptService/Decrypt", opts...)
	if err != nil {
		return nil, err
	}
	x := &cryptServiceDecryptClient{stream}
	return x, nil
}

type CryptService_DecryptClient interface {
	Send(*DecryptRequest) error
	Recv() (*DecryptResponse, error)
	grpc.ClientStream
}

type cryptServiceDecryptClient struct {
	grpc.ClientStream
}

func (x *cryptServiceDecryptClient) Send(m *DecryptRequest) error {
	return x.ClientStream.SendMsg(m)
}

func (x *cryptServiceDecryptClient) Recv() (*DecryptResponse, error) {
	m := new(DecryptResponse)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// CryptServiceServer is the server API for CryptService service.
// All implementations must embed UnimplementedCryptServiceServer
// for forward compatibility
type CryptServiceServer interface {
	Encrypt(CryptService_EncryptServer) error
	Decrypt(CryptService_DecryptServer) error
	mustEmbedUnimplementedCryptServiceServer()
}

// UnimplementedCryptServiceServer must be embedded to have forward compatible implementations.
type UnimplementedCryptServiceServer struct {
}

func (UnimplementedCryptServiceServer) Encrypt(CryptService_EncryptServer) error {
	return status.Errorf(codes.Unimplemented, "method Encrypt not implemented")
}
func (UnimplementedCryptServiceServer) Decrypt(CryptService_DecryptServer) error {
	return status.Errorf(codes.Unimplemented, "method Decrypt not implemented")
}
func (UnimplementedCryptServiceServer) mustEmbedUnimplementedCryptServiceServer() {}

// UnsafeCryptServiceServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CryptServiceServer will
// result in compilation errors.
type UnsafeCryptServiceServer interface {
	mustEmbedUnimplementedCryptServiceServer()
}

func RegisterCryptServiceServer(s grpc.ServiceRegistrar, srv CryptServiceServer) {
	s.RegisterService(&CryptService_ServiceDesc, srv)
}

func _CryptService_Encrypt_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(CryptServiceServer).Encrypt(&cryptServiceEncryptServer{stream})
}

type CryptService_EncryptServer interface {
	Send(*EncryptResponse) error
	Recv() (*EncryptRequest, error)
	grpc.ServerStream
}

type cryptServiceEncryptServer struct {
	grpc.ServerStream
}

func (x *cryptServiceEncryptServer) Send(m *EncryptResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *cryptServiceEncryptServer) Recv() (*EncryptRequest, error) {
	m := new(EncryptRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _CryptService_Decrypt_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(CryptServiceServer).Decrypt(&cryptServiceDecryptServer{stream})
}

type CryptService_DecryptServer interface {
	Send(*DecryptResponse) error
	Recv() (*DecryptRequest, error)
	grpc.ServerStream
}

type cryptServiceDecryptServer struct {
	grpc.ServerStream
}

func (x *cryptServiceDecryptServer) Send(m *DecryptResponse) error {
	return x.ServerStream.SendMsg(m)
}

func (x *cryptServiceDecryptServer) Recv() (*DecryptRequest, error) {
	m := new(DecryptRequest)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// CryptService_ServiceDesc is the grpc.ServiceDesc for CryptService service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var CryptService_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "cryptpb.CryptService",
	HandlerType: (*CryptServiceServer)(nil),
	Methods:     []grpc.MethodDesc{},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "Encrypt",
			Handler:       _CryptService_Encrypt_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
		{
			StreamName:    "Decrypt",
			Handler:       _CryptService_Decrypt_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "services.proto",
}
